package org.javacodegeeks.examples.v4;

import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import reactor.core.scheduler.Schedulers;
import reactor.math.MathFlux;

import java.time.Duration;
import java.util.List;

public class BufferCaveatExampleMain {
    public static void main(String[] args) {
        Flux.range(1, 100)
            .buffer(10)
            .log()
            .flatMap(BufferCaveatExampleMain::processBatch)
            .blockLast();
    }

    private static Mono<Integer> processBatch(List<Integer> integers) {
        return MathFlux.max(Flux.fromIterable(integers))
            .subscribeOn(Schedulers.boundedElastic())
            .delaySubscription(Duration.ofMinutes(1));
    }
}
