package org.javacodegeeks.examples.v4;

import reactor.core.publisher.Hooks;
import reactor.core.publisher.Mono;
import reactor.core.scheduler.Schedulers;

import java.util.concurrent.TimeUnit;

public class LostStacktraceExampleMain {
    public static void main(String[] args) throws InterruptedException {
        Hooks.onOperatorDebug();
        doLogic();
    }

    private static void doLogic() throws InterruptedException {
        Mono.just(1)
            .flatMap(LostStacktraceExampleMain::preProcessReactive)
            .subscribeOn(Schedulers.boundedElastic())
            .subscribe();

        TimeUnit.SECONDS.sleep(5);
    }

    private static int process(int i) {
        return i / 0;
    }

    private static Mono<Integer> preProcessReactive(int i) {
        return Mono.fromCallable(() -> process(i));
    }

}
