package org.javacodegeeks.examples.v4;


import jdk.incubator.concurrent.StructuredTaskScope;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

public class StackTraceLoomExample {

    public static void main(String[] args) {
        doLogic();
    }

    private static void doLogic() {
        try(var scope = new StructuredTaskScope.ShutdownOnFailure()) {
            List<Future<?>> futures = new ArrayList<>();
            for (int i = 0; i < 10000; i++) {
                int finalI = i;
                final var integerFuture = scope.fork(() -> finalI / (9000 - finalI));
                futures.add(integerFuture);
            }
            scope.join();
            scope.throwIfFailed();
        } catch (ExecutionException | InterruptedException e) {
            throw new RuntimeException(e);
        }
    }
}
